#-----------------------------------------------------------------------------
#                            CarthaGene
#
# Martin Bouchez, Patrick Chabrier, Christine Gaspin and Thomas Schiex. 
# Unite de Biometrie et Intelligence Artificielle, Toulouse, France
#
#  Copyright (C) 1997 INRA (Institut National de la Recherche Agronomique).
#
# $Id: CGconfigQuiet.tcl,v 1.3 2002-11-07 16:59:02 bouchez Exp $
#
#    This program is free software; you can redistribute it and/or modify
#  it under the terms of the GNU General Public License as published by
#  the Free Software Foundation; either version 2 of the License, or
#  (at your option) any later version.
#
#  This program is distributed in the hope that it will be useful,
#  but WITHOUT ANY WARRANTY; without even the implied warranty of
#  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#  GNU General Public License for more details.
#
#  You should have received a copy of the GNU General Public License
#  along with this program; if not, write to the Free Software
#  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
#
#
# Module 	: ihm
# Projet	: CartaGene
#
# Description : widget quiet : implmentation pour les valeurs par dfaut
#
# Divers : 
#-----------------------------------------------------------------------------
#-INRA---------------------Station de Biomtrie et d'Intelligence Artificielle
#-----------------------------------------------------------------------------

#
# Resources par dfaut
#

#
# Options usuelles.
#
itk::usual CGconfigQuiet {
    keep -command  -background -cursor -foreground
}


class CGconfigQuiet {
    inherit itk::Widget

    lappend auto_path .

    itk_option define -quiet quiet Quiet 0
    common quietv

    constructor {args} {}
    public method get {arg}
    public method cget {arg}
}


proc cgconfigquiet {pathName args} {
    uplevel CGconfigQuiet $pathName $args
}


body CGconfigQuiet::constructor {args} {
    
    itk_component add quiet {
        checkbutton $itk_interior.quiet \
	    -text Quiet \
	    -indicatoron 1 \
	    -variable [scope quietv]
    } {
	usual
	
	keep -command 
    }

    pack $itk_component(quiet)

    eval itk_initialize $args
}

configbody CGconfigQuiet::quiet {
    
    set nbr $itk_option(-quiet)
    if {$nbr != 0 && $nbr != 1}  {
        error "wrong value \"quiet\": should be 0 or 1"
    } else {
	if {$itk_option(-quiet) == 0} {
	    $itk_component(quiet) deselect
	} else {
	    $itk_component(quiet) select
	}  
    }
}

body CGconfigQuiet::get {arg} {
    
    switch -- $arg {
        "-quiet" { return $quietv}
        default {
            error "unknown parameter $arg."
        }
    }
}

body CGconfigQuiet::cget {arg} {

    return $itk_option($arg)

}
